searchData={"items":[{"type":"task","title":"mix docs","doc":"Uses ExDoc to generate a static web page from the project documentation.","ref":"Mix.Tasks.Docs.html"},{"type":"task","title":"Command line options - mix docs","doc":"* `--canonical`, `-n` - Indicate the preferred URL with\n    `rel=\"canonical\"` link element, defaults to no canonical path\n\n  * `--formatter`, `-f` - Which formatters to use, `html` or\n    `epub`. This option can be given more than once. By default,\n    both `html` and `epub` are generated.\n\n  * `--language` - Specifies the language to annotate the\n    EPUB output in valid [BCP 47](https://tools.ietf.org/html/bcp47)\n\n  * `--open` - open browser window pointed to the documentation\n\n  * `--output`, `-o` - Output directory for the generated\n    docs, default: `\"doc\"`\n\n  * `--proglang` - Chooses the main programming language: `elixir`\n    or `erlang`\n\n  * `--warnings-as-errors` - Exits with non-zero exit code if any warnings are found\n\nThe command line options have higher precedence than the options\nspecified in your `mix.exs` file below.","ref":"Mix.Tasks.Docs.html#module-command-line-options"},{"type":"task","title":"Configuration - mix docs","doc":"ExDoc will automatically pull in information from your project,\nlike the application and version. However, you may want to set\n`:name`, `:source_url` and `:homepage_url` to have a nicer output\nfrom ExDoc, for example:\n\n    def project do\n      [\n        app: :my_app,\n        version: \"0.1.0-dev\",\n        deps: deps(),\n\n        # Docs\n        name: \"My App\",\n        source_url: \"https://github.com/USER/PROJECT\",\n        homepage_url: \"http://YOUR_PROJECT_HOMEPAGE\",\n        docs: [\n          main: \"MyApp\", # The main page in the docs\n          favicon: \"path/to/favicon.png\",\n          logo: \"path/to/logo.png\",\n          extras: [\"README.md\"]\n        ]\n      ]\n    end\n\nExDoc also allows configuration specific to the documentation to\nbe set. The following options should be put under the `:docs` key\nin your project's main configuration. The `:docs` options should\nbe a keyword list or a function returning a keyword list that will\nbe lazily executed.\n\n  * `:annotations_for_docs` - a function that receives metadata and returns a list\n    of annotations to be added to the signature. The metadata received will also\n    contain `:module`, `:name`, `:arity` and `:kind` to help identify which entity is\n    currently being processed.\n\n  * `:api_reference` - Whether to generate `api-reference.html`; default: `true`.\n    If this is set to false, `:main` must also be set.\n\n  * `:assets` - A map of source => target directories that will be copied as is to\n    the output path. It defaults to an empty map.\n\n  * `:authors` - List of authors for the generated docs or epub.\n\n  * `:before_closing_body_tag` - a function that takes as argument an atom specifying\n    the formatter being used (`:html` or `:epub`) and returns a literal HTML string\n    to be included just before the closing body tag (` `).\n    The atom given as argument can be used to include different content in both formats.\n    Useful to inject custom assets, such as Javascript.\n\n  * `:before_closing_head_tag` - a function that takes as argument an atom specifying\n    the formatter being used (`:html` or `:epub`) and returns a literal HTML string\n    to be included just before the closing head tag (` `).\n    The atom given as argument can be used to include different content in both formats.\n    Useful to inject custom assets, such as CSS stylesheets.\n\n  * `:before_closing_footer_tag` - a function that takes as argument an atom specifying\n    the formatter being used (`:html`) and returns a literal HTML string\n    to be included just before the closing footer tag (` `).\n    This option only has effect on the html formatter.\n    Useful if you want to inject an extra footer into the documentation.\n\n  * `:canonical` - String that defines the preferred URL with the rel=\"canonical\"\n    element; defaults to no canonical path.\n\n  * `:cover` - Path to the epub cover image (only PNG or JPEG accepted)\n    The image size should be around 1600x2400. When specified, the cover will be placed under\n    the \"assets\" directory in the output path under the name \"cover\" and the\n    appropriate extension. This option has no effect when using the \"html\" formatter.\n\n  * `:deps` - A keyword list application names and their documentation URL.\n    ExDoc will by default include all dependencies and assume they are hosted on\n    HexDocs. This can be overridden by your own values. Example: `[plug: \"https://myserver/plug/\"]`\n\n  * `:extra_section` - String that defines the section title of the additional\n    Markdown and plain text pages; default: \"PAGES\". Example: \"GUIDES\"\n\n  * `:extras` - List of paths to additional Markdown (`.md` extension), Live Markdown\n    (`.livemd` extension), Cheatsheets (`.cheatmd` extension) and plain text pages to\n    add to the documentation. You can also specify keyword pairs to customize the\n    generated filename, title and source file, and search content of each extra page; default: `[]`. Example:\n    `[\"README.md\", \"LICENSE\", \"CONTRIBUTING.md\": [filename: \"contributing\", title: \"Contributing\", source: \"CONTRIBUTING.mdx\"]]`\n    See the Customizing Extras section for more.\n\n  * `:favicon` - Path to a favicon image file for the project. Must be PNG, JPEG or SVG. When\n    specified, the image file will be placed in the output \"assets\" directory, named\n    \"favicon.EXTENSION\". If using SVG, ensure appropriate width, height and viewBox attributes\n    are present in order to ensure predictable sizing and cropping.\n\n  * `:filter_modules` - Include only modules that match the given value. The\n    value can be a regex, a string (representing a regex), or a two-arity\n    function that receives the module and its metadata and returns true if the\n    module must be included. If a string or a regex is given, it will be matched\n    against the complete module name (which includes the \"Elixir.\" prefix for\n    Elixir modules). If a module has `@moduledoc false`, then it is always excluded.\n\n  * `:formatters` - Formatter to use; default: [\"html\", \"epub\"], options: \"html\", \"epub\".\n\n  * `:groups_for_extras`, `:groups_for_modules`, `:groups_for_docs`, and `:default_group_for_doc` -\n    See the \"Groups\" section\n\n  * `:ignore_apps` - Apps to be ignored when generating documentation in an umbrella project.\n    Receives a list of atoms. Example: `[:first_app, :second_app]`.\n\n  * `:language` - Identify the primary language of the documents, its value must be\n    a valid [BCP 47](https://tools.ietf.org/html/bcp47) language tag; default: \"en\"\n\n  * `:logo` - Path to a logo image file for the project. Must be PNG, JPEG or SVG. When\n    specified, the image file will be placed in the output \"assets\" directory, named\n    \"logo.EXTENSION\". The image will be shown within a 48x48px area. If using SVG, ensure\n    appropriate width, height and viewBox attributes are present in order to ensure\n    predictable sizing and cropping.\n\n  * `:main` - Main page of the documentation. It may be a module or a\n    generated page, like \"Plug\" or \"api-reference\"; default: \"api-reference\".\n\n  * `:markdown_processor` - The markdown processor to use,\n    either `module()` or `{module(), keyword()}` to provide configuration options;\n\n  * `:meta` - A keyword list or a map to specify meta tag attributes\n\n  * `:nest_modules_by_prefix` - See the \"Nesting\" section\n\n  * `:output` - Output directory for the generated docs; default: \"doc\".\n    May be overridden by command line argument.\n\n  * `:redirects` - A map or list of tuples, where the key is the path to redirect from and the\n     value is the path to redirect to. The extension is omitted in both cases, i.e `%{\"old-readme\" => \"readme\"}`.\n     See the \"Changing documentation over time\" section below for more.\n\n  * `:skip_undefined_reference_warnings_on` - ExDoc warns when it can't create a `Mod.fun/arity`\n    reference in the current project docs e.g. because of a typo. This list controls where to\n    skip the warnings, for a given module/function/callback/type (e.g.: `[\"Foo\", \"Bar.baz/0\"]`)\n    or on a given file (e.g.: `[\"pages/deprecations.md\"]`). This option can also be a function\n    from a reference string to a boolean (e.g.: `&String.match?(&1, ~r/Foo/)`);\n    default is nothing to be skipped.\n\n  * `:skip_code_autolink_to` - Similar to `:skip_undefined_reference_warnings_on`, this option\n    controls which terms will be skipped by ExDoc when building documentation.\n    Useful for example if you want to highlight private modules or functions without warnings.\n    This option can be a function from a term to a boolean (e.g.: `&String.match?(&1, ~r/PrivateModule/)`)\n    or a list of terms (e.g.:`[\"PrivateModule\", \"PrivateModule.func/1\"]`);\n    default is nothing to be skipped.\n\n  * `:source_beam` - Path to the beam directory; default: mix's compile path.\n\n  * `:source_ref` - The branch/commit/tag used for source link inference;\n    default: \"main\".\n\n  * `:source_url_pattern` - Public URL of the project for source links. This is derived\n    automatically from the project's `:source_url` and `:source_ref` when using one of\n    the supported public hosting services (currently GitHub, GitLab, or Bitbucket). If\n    you are using one of those services with their default public hostname, you do not\n    need to set this configuration.\n\n    However, if using a different solution, or self-hosting, you will need to set this\n    configuration variable to a pattern for source code links. The value must be a string or\n    a function.\n\n    If a string, then it should be the full URI to use for links with the following\n    variables available for interpolation:\n\n      * `%{path}`: the path of a file in the repo\n      * `%{line}`: the line number in the file\n\n    For GitLab/GitHub:\n\n    ```text\n    https://mydomain.org/user_or_team/repo_name/blob/main/%{path}#L%{line}\n    ```\n\n    For Bitbucket:\n\n    ```text\n    https://mydomain.org/user_or_team/repo_name/src/main/%{path}#cl-%{line}\n    ```\n\n    If a function, then it must be a function that takes two arguments, path and line,\n    where path is either an relative path from the cwd, or an absolute path. The function\n    must return the full URI as it should be placed in the documentation.","ref":"Mix.Tasks.Docs.html#module-configuration"},{"type":"task","title":"Groups - mix docs","doc":"ExDoc content can be organized in groups. This is done via the `:groups_for_extras`\nand `:groups_for_modules`. For example, imagine you are storing extra guides in\nyour documentation which are organized per directory. In the extras section you\nhave:\n\n    extras: [\n      \"guides/introduction/foo.md\",\n      \"guides/introduction/bar.md\",\n\n      ...\n\n      \"guides/advanced/baz.md\",\n      \"guides/advanced/bat.md\"\n    ]\n\nYou can have those grouped as follows:\n\n    groups_for_extras: [\n      \"Introduction\": Path.wildcard(\"guides/introduction/*.md\"),\n      \"Advanced\": Path.wildcard(\"guides/advanced/*.md\")\n    ]\n\nOr via a regex:\n\n    groups_for_extras: [\n      \"Introduction\": ~r\"/introduction/\",\n      \"Advanced\": ~r\"/advanced/\"\n    ]\n\nSimilar can be done for modules:\n\n    groups_for_modules: [\n      \"Data types\": [Atom, Regex, URI],\n      \"Collections\": [Enum, MapSet, Stream]\n    ]\n\nA regex or the string name of the module is also supported.","ref":"Mix.Tasks.Docs.html#module-groups"},{"type":"task","title":"Grouping functions, types, and callbacks - mix docs","doc":"Types, functions, and callbacks inside a module can also be organized in groups.\nBy default, ExDoc respects the `:group` metadata field:\n\n    @doc group: \"Queries\"\n    def get_by(schema, fields)\n\nThe function above will be automatically listed under the \"Queries\" section in\nthe sidebar. The benefit of using `:group` is that it can also be used by tools\nsuch as IEx during autocompletion. These groups are then ordered alphabetically\nin the sidebar.\n\nIt is also possible to tell ExDoc to either enrich the group metadata or lookup a\ndifferent field via the `:default_group_for_doc` configuration. The default is:\n\n    default_group_for_doc: fn metadata -> metadata[:group] end\n\nThe `metadata` received contains all of the documentation metadata, such as `:group`,\nbut also `:module`, `:name`, `:arity` and `:kind` to help identify which entity is\ncurrently being processed. For example, projects like Nx have a custom function that\nconverts \"Queries\" into \"Function: Queries\":\n\n    default_group_for_doc: fn metadata ->\n      if group = metadata[:group] do\n        \"Functions: #{group}\"\n      end\n    end\n\nWhenever using the `:group` key, the groups will be ordered alphabetically.\nIf you also want control over the group order, you can also use the `:groups_for_docs`\nwhich works similarly as the one for modules/extra pages.\n\n`:groups_for_docs` is a keyword list of group titles and filtering functions\nthat receive the documentation metadata and must return a boolean.\nFor example, imagine that you have an API client library with a large surface\narea for all the API endpoints you need to support. It would be helpful to\ngroup the functions with similar responsibilities together. In this case in\nyour module you might have:\n\n    defmodule APIClient do\n      @doc section: :auth\n      def refresh_token(params \\\\ [])\n\n      @doc subject: :object\n      def update_status(id, new_status)\n\n      @doc permission: :grant\n      def grant_privilege(resource, privilege)\n    end\n\nAnd then in the configuration you can group these with:\n\n    groups_for_docs: [\n      Authentication: & &1[:section] == :auth,\n      Resource: & &1[:subject] == :object,\n      Admin: & &1[:permission] in [:grant, :write]\n    ]\n\nA function can belong to a single group only. The first group that matches\nwill be the one used. In case no group is found in `:groups_for_docs`,\nthe `:default_group_for_doc` callback is invoked. If it returns nil, it\nthen falls back to the appropriate \"Functions\", \"Types\" or \"Callbacks\"\nsection respectively.","ref":"Mix.Tasks.Docs.html#module-grouping-functions-types-and-callbacks"},{"type":"task","title":"Meta-tags configuration - mix docs","doc":"It is also possible to configure some of ExDoc behaviour using meta tags.\nThese meta tags can be inserted using `before_closing_head_tag`.\n\n  * `exdoc:autocomplete` - when set to \"off\", it disables autocompletion.\n\n  * `exdoc:full-text-search-url` - the URL to use when performing full text\n    search. The search string will be appended to the URL as an encoded\n    parameter. You could use this to bring a custom search engine to your\n    documentation. It defaults to ExDoc's default search page.","ref":"Mix.Tasks.Docs.html#module-meta-tags-configuration"},{"type":"task","title":"Nesting - mix docs","doc":"ExDoc also allows module names in the sidebar to appear nested under a given\nprefix. The `:nest_modules_by_prefix` expects a list of module names, such as\n`[Foo.Bar, Bar.Baz]`. In this case, a module named `Foo.Bar.Baz` will appear\nnested within `Foo.Bar` and only the name `Baz` will be shown in the sidebar.\nNote the `Foo.Bar` module itself is not affected.\n\nThis option is mainly intended to improve the display of long module names in\nthe sidebar, particularly when they are too long for the sidebar or when many\nmodules share a long prefix. If you mean to group modules logically or call\nattention to them in the docs, you should probably use `:groups_for_modules`\n(which can be used in conjunction with `:nest_modules_by_prefix`).","ref":"Mix.Tasks.Docs.html#module-nesting"},{"type":"task","title":"Changing documentation over time - mix docs","doc":"As your project grows, your documentation may very likely change, even structurally.\nThere are a few important things to consider in this regard:\n\n  * Links to your *extras* will break if you change or move file names.\n  * Links to your *modules, and mix tasks* will change if you change their name.\n  * Links to *functions* are actually links to modules with anchor links.\n    If you change the function name, the link does not break but will leave users\n    at the top of the module's documentation.\n\nBecause these docs are static files, the behavior of a missing page will depend on where they are hosted.\nIn particular, [hexdocs.pm](https://hexdocs.pm) will show a 404 page.\n\nYou can improve the developer experience on everything but function names changing\nby using the `redirects` configuration. For example, if you changed the module `MyApp.MyModule`\nto `MyApp.My.Module` and the extra `get-started.md` to `quickstart.md`, you can\nsetup the following redirects:\n\n    redirects: %{\n      \"MyApp.MyModule\" => \"MyApp.My.Module\",\n      \"get-started\" => \"quickstart\"\n    }","ref":"Mix.Tasks.Docs.html#module-changing-documentation-over-time"},{"type":"task","title":"Customizing Extras - mix docs","doc":"* `:title` - The title of the extra page. If not provided, the title will be inferred from the filename.\n  * `:filename` - The name of the generated file. If not provided, the filename will be inferred from\n     the source file.\n  * `:source` - The source file of the extra page. This is useful if you want to customize the filename or\n     title but keep the source file unchanged.\n  * `:search_data` - A list of terms to be indexed for autocomplete and search. If not provided, the content\n     of the extra page will be indexed for search. See the section below for more.","ref":"Mix.Tasks.Docs.html#module-customizing-extras"},{"type":"task","title":"Customizing Search Data - mix docs","doc":"It is possible to fully customize the way a given extra is indexed, both in autocomplete and in search.\nIn most cases, this makes sense for _generated_ documentation. If `search_data` is provided, it completely\noverrides the built in logic for indexing your document based on the headers and content of the document.\nThe following fields can be provided in a list of maps for `search_data`.\n\n  * `:anchor` - The anchor link for the search result. Use `\"\"` to point to the top of the page.\n  * `:title` - The title of the result.\n  * `:type` - The type of the search result, such as \"module\", \"function\" or \"section\".\n  * `:body` - The main content or body of the search result, _as markdown_. Used in search, not autocomplete.","ref":"Mix.Tasks.Docs.html#module-customizing-search-data"},{"type":"task","title":"Umbrella project - mix docs","doc":"ExDoc can be used in an umbrella project and generates a single documentation\nfor all child apps. You can use the `:ignore_apps` configuration to exclude\ncertain projects in the umbrella from documentation.\n\nGenerating documentation per each child app can be achieved by running:\n\n    mix cmd mix docs\n\nSee `mix help cmd` for more information.","ref":"Mix.Tasks.Docs.html#module-umbrella-project"},{"type":"behaviour","title":"ExDoc.Markdown","doc":"Adapter behaviour and conveniences for converting Markdown to HTML.\n\nExDoc is compatible with any markdown processor that implements the\nfunctions defined in this module. The markdown processor can be changed\nvia the `:markdown_processor` option in your `mix.exs`.\n\nExDoc supports the following Markdown parsers out of the box:\n\n  * [EarmarkParser](https://github.com/robertdober/earmark_parser)\n\nExDoc uses EarmarkParser by default.","ref":"ExDoc.Markdown.html"},{"type":"callback","title":"ExDoc.Markdown.available?/0","doc":"Returns true if all dependencies necessary are available.","ref":"ExDoc.Markdown.html#c:available?/0"},{"type":"function","title":"ExDoc.Markdown.get_markdown_processor/0","doc":"Gets the current markdown processor set globally.","ref":"ExDoc.Markdown.html#get_markdown_processor/0"},{"type":"function","title":"ExDoc.Markdown.put_markdown_processor/1","doc":"Changes the markdown processor globally.","ref":"ExDoc.Markdown.html#put_markdown_processor/1"},{"type":"function","title":"ExDoc.Markdown.to_ast/2","doc":"Converts the given markdown document to HTML AST.","ref":"ExDoc.Markdown.html#to_ast/2"},{"type":"callback","title":"ExDoc.Markdown.to_ast/2","doc":"Converts markdown into HTML.","ref":"ExDoc.Markdown.html#c:to_ast/2"},{"type":"module","title":"ExDoc.Markdown.Earmark","doc":"ExDoc extension for the EarmarkParser Markdown parser.","ref":"ExDoc.Markdown.Earmark.html"},{"type":"function","title":"ExDoc.Markdown.Earmark.to_ast/2","doc":"Generate HTML AST.","ref":"ExDoc.Markdown.Earmark.html#to_ast/2"},{"type":"function","title":"Options - ExDoc.Markdown.Earmark.to_ast/2","doc":"* `:gfm` - (boolean) turns on Github Flavored Markdown extensions. Defaults to `true`.\n\n  * `:breaks` - (boolean) only applicable if `gfm` is enabled. Makes all line\n    breaks significant (so every line in the input is a new line in the output).","ref":"ExDoc.Markdown.Earmark.html#to_ast/2-options"},{"type":"extras","title":"ExDoc","doc":"# ExDoc\n\n[![Build Status](https://github.com/elixir-lang/ex_doc/workflows/CI/badge.svg)](https://github.com/elixir-lang/ex_doc/actions?query=workflow%3A%22CI%22)\n\nExDoc is a tool to generate documentation for Erlang and Elixir projects. To see an example, [you can access Elixir's official docs](https://hexdocs.pm/elixir/).","ref":"readme.html"},{"type":"extras","title":"Features - ExDoc","doc":"ExDoc ships with many features:\n\n  * Automatically generates offline-accessible HTML and EPUB documents from your API documentation.\n  * When hosted, ExDoc relies on browser's page transitions for better UX, caching, and enhanced accessibility.\n  * Responsive design, covering phones and tablets.\n  * Support for custom pages, guides, livebooks and cheatsheets.\n  * Support for custom grouping of modules, functions, and pages in the sidebar.\n  * Customizable logo and favicon.\n  * A direct link back to the source code for every documented entity.\n  * Full-text search.\n  * Keyboard shortcuts. (Press `?` to show help.)\n  * Quick-search with autocompletion support. (`s` keyboard shortcut.)\n  * Go-to shortcut with auto-complete to take the reader to any HexDocs package documentation. (`g` keyboard shortcut.)\n  * Support for night mode, activated according to the browser preference.\n  * Tooltips for links to modules and functions, both for the current project and other projects.\n  * Version dropdown and \"Go to latest\" notifications, automatically configured when hosted on HexDocs.","ref":"readme.html#features"},{"type":"extras","title":"Usage - ExDoc","doc":"You can use ExDoc with Mix (recommended for Elixir projects), with Rebar (recommended for Erlang projects), or via the command line.\n\n<!-- tabs-open -->","ref":"readme.html#usage"},{"type":"extras","title":"Mix - ExDoc","doc":"ExDoc requires Elixir v1.12 or later. Then add ExDoc as a dependency:\n\n```elixir\ndef deps do\n  [\n    {:ex_doc, \"~> 0.34\", only: :dev, runtime: false},\n  ]\nend\n```\n\nThen run `mix deps.get`.\n\n> #### Erlang development environment {: .warning}\n>\n> Some Operating System distributions split Erlang into multiple packages, and at least one ExDoc dependency (`earmark_parser`) requires the Erlang development environment. If you see a message like \"/usr/lib/erlang/lib/parsetools-2.3.1/include/yeccpre.hrl: no such file or directory\", it means you lack this environment. For instance, on the Debian operating system and its derivatives, you need to `apt install erlang-dev`.\n\nExDoc will automatically pull in information from your projects, such as the application and version. However, you may want to set `:name`, `:source_url` and `:homepage_url` in order to have nicer output from ExDoc:\n\n```elixir\ndef project do\n  [\n    app: :my_app,\n    version: \"0.1.0-dev\",\n    deps: deps(),\n\n    # Docs\n    name: \"MyApp\",\n    source_url: \"https://github.com/USER/PROJECT\",\n    homepage_url: \"http://YOUR_PROJECT_HOMEPAGE\",\n    docs: &docs/0\n  ]\nend\n\ndefp docs do\n  [\n    main: \"MyApp\", # The main page in the docs\n    logo: \"path/to/logo.png\",\n    extras: [\"README.md\"]\n  ]\nend\n```\n\nNow you are ready to generate your project documentation with `mix docs`. To see all options available, run `mix help docs`.\n\nTo learn about how to document your projects, see [Elixir's writing documentation page](https://hexdocs.pm/elixir/writing-documentation.html).","ref":"readme.html#mix"},{"type":"extras","title":"Rebar3 - ExDoc","doc":"From Erlang/OTP 24+, you can use ExDoc to render your Erlang documentation written with EDoc. See [`rebar3_ex_doc`](https://github.com/starbelly/rebar3_ex_doc/) for more information.","ref":"readme.html#rebar3"},{"type":"extras","title":"CLI - ExDoc","doc":"You can use ExDoc via the command line.\n\n1. Install ExDoc as an escript:\n\n   ```bash\n   $ mix escript.install hex ex_doc\n   ```\n\n2. Now you are ready to use it in your projects. Move into your project directory and make sure it's compiled:\n\n   ```bash\n   $ cd PATH_TO_YOUR_PROJECT\n   $ mix compile\n   ```\n\n3. Invoke the `ex_doc` executable from your project:\n\n   ```bash\n   $ ex_doc \"PROJECT_NAME\" \"PROJECT_VERSION\" _build/dev/lib/project/ebin -m \"PROJECT_MODULE\" -u \"https://github.com/GITHUB_USER/GITHUB_REPO\" -l path/to/logo.png\n   ```\n\n   Examples of appropriate values:\n\n   ```plain\n   PROJECT_NAME    => Ecto\n   PROJECT_VERSION => 0.1.0\n   PROJECT_MODULE  => Ecto (the main module provided by the library)\n   GITHUB_USER     => elixir-lang\n   GITHUB_REPO     => ecto\n   ```\n\nYou can specify a config file via the `--config` option, both Elixir and Erlang formats are supported. Invoke `ex_doc` without arguments to learn more.\n\n<!-- tabs-close -->","ref":"readme.html#cli"},{"type":"extras","title":"Syntax highlighting - ExDoc","doc":"ExDoc uses [the makeup project](https://github.com/elixir-makeup/makeup) for syntax highlighting. By default, highlighters for Erlang and Elixir are included. To syntax-highlight other languages, simply add the equivalent `makeup_LANGUAGE` package to your `mix.exs`/`rebar.config` file. For example, for HTML support you would add:\n\n<!-- tabs-open -->","ref":"readme.html#syntax-highlighting"},{"type":"extras","title":"Elixir (Mix) - ExDoc","doc":"```elixir\n{:makeup_html, \">= 0.0.0\", only: :dev, runtime: false}\n```","ref":"readme.html#elixir-mix"},{"type":"extras","title":"Erlang (Rebar3) - ExDoc","doc":"```erlang\n{makeup_html, \"0.1.1\"}\n```\n\n<!-- tabs-close -->\n\nYou can find all supported languages under [the Makeup organization on GitHub](https://github.com/elixir-makeup) and view them at [Makeup's website](https://elixir-makeup.github.io/makeup_demo/).","ref":"readme.html#erlang-rebar3"},{"type":"extras","title":"Additional pages - ExDoc","doc":"You can publish additional pages in your project documentation by configuring them as `:extras`. The following formats and extensions are supported:\n\n  * Markdown (`.md` extension) - useful for general long-term text. [Learn more](https://daringfireball.net/projects/markdown/syntax).\n\n  * Cheatsheets (`.cheatmd` extension) - useful for discovery and quick reference. [Learn more](https://hexdocs.pm/ex_doc/cheatsheet.html).\n\n  * Livebooks (`.livemd` extension) - useful for tutorials, interactive examples, and deep dives. [Learn more](https://livebook.dev/).\n\nFor example, you can set your `:extras` to:\n\n<!-- tabs-open -->","ref":"readme.html#additional-pages"},{"type":"extras","title":"Elixir - ExDoc","doc":"```elixir\nextras: [\"README.md\", \"LICENSE\", \"tutorial.livemd\", \"cheatsheet.cheatmd\"]\n```\n\nRun `mix help docs` for more information on configuration.","ref":"readme.html#elixir"},{"type":"extras","title":"Erlang - ExDoc","doc":"```elixir\n{extras, [<<\"README.md\">>, <<\"cheatsheet.cheatmd\">>]}.\n```\n\n<!-- tabs-close -->","ref":"readme.html#erlang"},{"type":"extras","title":"Metadata - ExDoc","doc":"ExDoc supports metadata keys in your documentation.\n\n<!-- tabs-open -->","ref":"readme.html#metadata"},{"type":"extras","title":"Elixir - ExDoc","doc":"In Elixir, you can add metadata to modules and functions.\n\nFor a module, use `@moduledoc`, which is equivalent to adding the annotation to everything inside the module (functions, macros, callbacks, types):\n\n```elixir\n@moduledoc since: \"1.10.0\"\n```\n\nFor a function, use `@doc`:\n\n```elixir\n@doc since: \"1.13.1\"\n```","ref":"readme.html#elixir"},{"type":"extras","title":"Erlang - ExDoc","doc":"In Erlang's EDoc:\n\n```erlang\n%% @since 0.1.0\n```\n\n<!-- tabs-close -->\n\nThe following metadata is available for both modules and functions:\n\n  * `deprecated` (binary) - marks a module/function as deprecated, with the given string as the reason.\n  * `since` (binary) - declares a module/function available from a particular version.\n\nThe following metadata is available for modules:\n\n  * `tags` (list of atoms) - a list of strings to be added as tags to the module. (Not supported by EDoc.)","ref":"readme.html#erlang"},{"type":"extras","title":"Auto-linking - ExDoc","doc":"ExDoc for Elixir and Erlang will automatically generate links across modules and functions if you enclose them in backticks.\n\n<!-- tabs-open -->","ref":"readme.html#auto-linking"},{"type":"extras","title":"Elixir - ExDoc","doc":"ExDoc will automatically link modules, functions, types or callbacks defined in your project and its dependencies (including Erlang and Elixir). ExDoc will automatically link to it at the dependency's documentation at [hexdocs.pm](https://hexdocs.pm/). The link can be configured by setting `docs: [deps: [my_dep: \"https://path/to/docs/\"]]` in your `mix.exs`.\n\nExDoc supports linking to modules (`` `MyModule` `` and `` `m:MyModule` ``), functions (`` `MyModule.function/1` ``), types (`` `t:MyModule.type/2` ``) and callbacks (`` `c:MyModule.callback/3` ``). If you want to link a function, type or callback in the current module, you may skip the module name, for example: `` `function/1` ``.\n\nYou can also use custom text, such as `` [custom text](`MyModule.function/1`) ``. Link to extra pages using the syntax `` [Up and running](Up and running.md) ``. The final link will be automatically converted to `up-and-running.html`.\n\nLink to extra pages in another application using the syntax `` [Writing Documentation](`e:elixir:writing-documentation.html`) ``, skipping the directory in which the page is. The final link will be automatically converted to `https://hexdocs.pm/elixir/writing-documentation.html`.\n\nIt is also possible to place anchors after the module name and extra pages. For example:\n\n  * `` `m:Keyword#module-duplicate-keys-and-ordering` `` will create a link to `https://hexdocs.pm/elixir/Keyword.html#module-duplicate-keys-and-ordering`\n\n  * `` `e:elixir:syntax-reference.md#expressions` `` will create a link to `https://hexdocs.pm/elixir/syntax-reference.html#expressions`","ref":"readme.html#elixir"},{"type":"extras","title":"Erlang - ExDoc","doc":"ExDoc will automatically link modules, functions, types or callbacks defined in your project and its dependencies (including Erlang and Elixir). ExDoc will automatically link to it at the dependency's documentation at [hexdocs.pm](https://hexdocs.pm/). The link can be configured by setting `docs: [deps: [my_dep: \"https://path/to/docs/\"]]` in your `mix.exs`. The link can be configured by setting `{docs, [{deps,  [{my_dep, \"https://path/to/docs/\"}]}]}` in your `rebar3.config`.\n\nExDoc supports linking to modules (`` `m:my_module` ``), functions (`` `my_module:function/1` ``), types (`` `t:my_module:type/2` ``) and callbacks (`` `c:my_module:callback/3` ``). If you want to link a function, type or callback in the current module, you may skip the module name; e.g.: `` `function/1` ``.\n\nYou can also use custom text, such as `` [custom text](`my_module:function/1`) ``. This also allows you to refer to Erlang/OTP modules: `` [The array module](`array`) `` (note that when a module is given as the link target, it is not necessary nor possible to use the `m:` prefix).\n\nLink to extra pages using the syntax `` [Up and running](Up and running.md) ``. The final link will be automatically converted to `up-and-running.html`.\n\nLink to extra pages in another application using the syntax `` [Using unicode](`e:stdlib:unicode_usage.html`) ``, skipping the directory in which the page is. The final link will be automatically converted to `https://hexdocs.pm/elixir/writing-documentation.html`.\n\nIt is also possible to place anchors after the module name and extra pages. For example:\n\n  * `` `m:argparse#quick-start` `` will create a link to `https://erlang.org/doc/man/argparse#quick-start`\n\n  * `` `e:stdlib:unicode-usage.md#what-unicode-is` `` will create a link to `https://erlang.org/doc/apps/stdlib/unicode-usage.html#what-unicode-is`\n\n<!-- tabs-close -->","ref":"readme.html#erlang"},{"type":"extras","title":"Admonition blocks - ExDoc","doc":"You may want to draw attention to certain statements by taking them out of the content's flow and labeling them with a priority. Such statements are called admonitions. (They are also known as asides or callouts.) An admonition block is rendered based on the assigned label or class. ExDoc supports `warning`, `error`, `info`, `tip` and `neutral` tags, on header levels `h3` and `h4`.\n\nThe syntax is as follows:\n\n```markdown\n> #### Error {: .error}\n>\n> This syntax will render an error block\n```\n\nThe result for the previous syntax is:\n\n> #### Error {: .error}\n>\n> This syntax will render an error block\n\nFor example, if you change the class name to `neutral`, you get the same admonition block in neutral style:\n\n> #### Neutral {: .neutral}\n>\n> This syntax will render a neutral block","ref":"readme.html#admonition-blocks"},{"type":"extras","title":"Tabsets - ExDoc","doc":"Where only one section of content of a series is likely to apply to the reader, you may wish to define a set of tabs.\n\nThis example contains code blocks, separating them into tabs based on language:\n\n<!-- tabs-open -->","ref":"readme.html#tabsets"},{"type":"extras","title":"Elixir - ExDoc","doc":"```elixir\nIO.puts \"Hello, world!\"\n```","ref":"readme.html#elixir"},{"type":"extras","title":"Erlang - ExDoc","doc":"```erlang\nio:fwrite(\"Hello, world!\\n\").\n```\n\n<!-- tabs-close -->\n\nTabbed content must be defined between `<!-- tabs-open -->` and `<!-- tabs-close -->` HTML comments. Each `h3` heading results in a new tab panel, with its text setting the tab button label.\n\nHere is the above example's source:\n\n````markdown\n<!-- tabs-open -->","ref":"readme.html#erlang"},{"type":"extras","title":"Elixir - ExDoc","doc":"```elixir\nIO.puts \"Hello, world!\"\n```","ref":"readme.html#elixir"},{"type":"extras","title":"Erlang - ExDoc","doc":"```erlang\nio:fwrite(\"Hello, world!\\n\").\n```\n\n<!-- tabs-close -->\n````","ref":"readme.html#erlang"},{"type":"extras","title":"Extensions - ExDoc","doc":"ExDoc renders Markdown content for you, but you can extend it to render complex objects on the page using JavaScript. To inject custom JavaScript into every page, add this to your configuration:\n\n```elixir\ndocs: [\n  # ...\n  before_closing_head_tag: &before_closing_head_tag/1,\n  before_closing_body_tag: &before_closing_body_tag/1\n]\n\n# ...\n\ndefp before_closing_head_tag(:html) do\n  \"\"\"\n  <!-- HTML injected at the end of the   element -->\n  \"\"\"\nend\n\ndefp before_closing_head_tag(:epub), do: \"\"\n\ndefp before_closing_body_tag(:html) do\n  \"\"\"\n  <!-- HTML injected at the end of the   element -->\n  \"\"\"\nend\n\ndefp before_closing_body_tag(:epub), do: \"\"\n```\n\nBesides an anonymous function, you can also pass a `module-function-args` tuple. It will call the given module and function, with the format prefixed to the arguments:\n\n```elixir\ndocs: [\n  # ...\n  before_closing_head_tag: {MyModule, :before_closing_head_tag, []},\n  before_closing_body_tag: {MyModule, :before_closing_body_tag, []}\n]\n```\n\nOr you can pass a map where the key is the format:\n\n```elixir\ndocs: [\n  # ...\n  before_closing_head_tag: %{html: \"...\", epub: \"...\"},\n  before_closing_body_tag: %{html: \"...\", epub: \"...\"}\n]\n```\n\nOn the JavaScript side, ExDoc emits the `\"exdoc:loaded\"` event. This event may be called multiple times, as you navigate across pages, so initialization that should happen only once must be conditional. We recommend external scripts to use `defer`, not `async`, as shown in the examples below.","ref":"readme.html#extensions"},{"type":"extras","title":"Rendering Math - ExDoc","doc":"If you write TeX-style math in your Markdown, such as `$\\sum_{i}^{N} x_i$`, it ends up as raw text on the generated pages. To render expressions, we recommend using [KaTeX](https://katex.org/), a JavaScript library that turns expressions into graphics. To load and trigger KaTeX on every documentation page, we can insert the following HTML:\n\n```html\n \n  \n\n \n  \n\n  \n\n \n  window.addEventListener(\"exdoc:loaded\", () => {\n    renderMathInElement(document.body, {\n      delimiters: [\n        {left: '$$', right: '$$', display: true},\n        {left: '$', right: '$', display: false},\n      ]\n    })\n  })\n \n```\n\nFor more details and configuration options, see the [KaTeX Auto-render Extension](https://katex.org/docs/autorender.html).","ref":"readme.html#rendering-math"},{"type":"extras","title":"Rendering Vega-Lite plots - ExDoc","doc":"Snippets are also objects you may want to render in a special manner. For example, assuming your Markdown includes Vega-Lite specification in `vega-lite` code snippets:\n\n```html\n  \n  \n  \n \n  window.addEventListener(\"exdoc:loaded\", () => {\n    for (const codeEl of document.querySelectorAll(\"pre code.vega-lite\")) {\n      try {\n        const preEl = codeEl.parentElement;\n        const spec = JSON.parse(codeEl.textContent);\n        const plotEl = document.createElement(\"div\");\n        preEl.insertAdjacentElement(\"afterend\", plotEl);\n        vegaEmbed(plotEl, spec);\n        preEl.remove();\n      } catch (error) {\n        console.log(\"Failed to render Vega-Lite plot: \" + error)\n      }\n    }\n  });\n \n```\n\nFor more details and configuration options, see [vega/vega-embed](https://github.com/vega/vega-embed).","ref":"readme.html#rendering-vega-lite-plots"},{"type":"extras","title":"Rendering Mermaid graphs - ExDoc","doc":"Similarly to the example above, if your Markdown includes Mermaid graph specification in `mermaid` code snippets:\n\n```html\n  \n \n  let initialized = false;\n\n  window.addEventListener(\"exdoc:loaded\", () => {\n    if (!initialized) {\n      mermaid.initialize({\n        startOnLoad: false,\n        theme: document.body.className.includes(\"dark\") ? \"dark\" : \"default\"\n      });\n      initialized = true;\n    }\n\n    let id = 0;\n    for (const codeEl of document.querySelectorAll(\"pre code.mermaid\")) {\n      const preEl = codeEl.parentElement;\n      const graphDefinition = codeEl.textContent;\n      const graphEl = document.createElement(\"div\");\n      const graphId = \"mermaid-graph-\" + id++;\n      mermaid.render(graphId, graphDefinition).then(({svg, bindFunctions}) => {\n        graphEl.innerHTML = svg;\n        bindFunctions?.(graphEl);\n        preEl.insertAdjacentElement(\"afterend\", graphEl);\n        preEl.remove();\n      });\n    }\n  });\n \n```\n\nFor more details and configuration options, see the [Mermaid usage docs](https://mermaid-js.github.io/mermaid/#/usage).","ref":"readme.html#rendering-mermaid-graphs"},{"type":"extras","title":"Contributing - ExDoc","doc":"The easiest way to test changes to ExDoc is to locally rebuild the app and its own documentation:\n\n  1. Run `mix setup` to install all dependencies\n  2. Run `mix build` to generate the docs and open up the generated `doc/index.html`\n  3. (optional) Run `erl -S httpd serve doc/` to serve the docs locally\n  4. (optional) Run `npm run --prefix assets build:watch` if working on assets for automatic recompilation\n  5. Run `mix lint` to check linting and formatting (and `mix fix` to automatically fix it)\n  6. (important) Do not add the files in the `formatters/` directory to your commits, those will be handled by the maintainers\n\nSee the README in the `assets/` directory for more information on working on the assets.","ref":"readme.html#contributing"},{"type":"extras","title":"License - ExDoc","doc":"ExDoc source code is released under the Apache 2 License. The generated contents, however, are under different licenses based on projects used to help render HTML, including CSS, JS, and other assets.\n\nAny documentation generated by ExDoc, or any documentation generated by any \"Derivative Works\" (as specified in the Apache 2 License), must include a direct, readable, and visible link to the [ExDoc repository](https://github.com/elixir-lang/ex_doc) on each rendered material. For HTML pages, every single page is a rendered material. For PDF, EPUB and other ebook formats, the whole body of documentation is a rendered material.","ref":"readme.html#license"},{"type":"extras","title":"Cheatsheet Example","doc":"# Cheatsheet Example\n\nCheatsheets are Markdown files with the `.cheatmd` extension which support a limited range of elements and formatting. Refer to the source of this document to see the relevant Markdown.","ref":"cheatsheet.html"},{"type":"extras","title":"H2 title - Cheatsheet Example","doc":"{: .col-2}","ref":"cheatsheet.html#h2-title"},{"type":"extras","title":"H3 title - Cheatsheet Example","doc":"#### H4 title\n\nA paragraph.","ref":"cheatsheet.html#h3-title"},{"type":"extras","title":"Code - Cheatsheet Example","doc":"```elixir\n# hello.exs\ndefmodule Greeter do\n  def greet(name) do\n    message = \"Hello, \" <> name <> \"!\"\n    IO.puts message\n  end\nend\n\nGreeter.greet(\"world\")\n```","ref":"cheatsheet.html#code"},{"type":"extras","title":"Paragraphs - Cheatsheet Example","doc":"Paragraphs are also supported and can quote `code`.\n\nParagraphs are visually distinct from one another.","ref":"cheatsheet.html#paragraphs"},{"type":"extras","title":"Lists - Cheatsheet Example","doc":"- Element 1\n- Element 2\n- `piece of code`","ref":"cheatsheet.html#lists"},{"type":"extras","title":"Table - Cheatsheet Example","doc":"#### Date (H4 header)\n\n| Example         | Output                 |\n| ---             | ---                    |\n| `%m/%d/%Y`      | `06/05/2013`           |\n| `%A, %B %e, %Y` | `Sunday, June 5, 2013` |\n| `%b %e %a`      | `Jun 5 Sun`            |\n\n### [Link](`mix docs`)\n\nHeader with links in it.","ref":"cheatsheet.html#table"},{"type":"extras","title":"Variants - Cheatsheet Example","doc":"{: .col-2}","ref":"cheatsheet.html#variants"},{"type":"extras","title":"Adding variants - Cheatsheet Example","doc":"```","ref":"cheatsheet.html#adding-variants"},{"type":"extras","title":"H2 - Cheatsheet Example","doc":"{: .col-2}","ref":"cheatsheet.html#h2"},{"type":"extras","title":"H3 - Cheatsheet Example","doc":"{: .list-6}\n\n* example 1\n* example 2\n```\n\nVariants change presentation via Markdown's inline attribute notation.","ref":"cheatsheet.html#h3"},{"type":"extras","title":"Header variants - Cheatsheet Example","doc":"#### H2\n\n| `.col-2` | two-columns |\n| `.col-3` | three-columns |\n| `.col-2-left` | two-columns (1/3 - 2/3) |\n\n#### H3\n\n| `.list-4` | four-columns for lists |\n| `.list-6` | six-columns for lists |","ref":"cheatsheet.html#header-variants"},{"type":"extras","title":"Code - Cheatsheet Example","doc":"{: .col-3}","ref":"cheatsheet.html#code"},{"type":"extras","title":"Code with headings - Cheatsheet Example","doc":"#### index.ex\n\n```\nPath.join([\"~\", \"foo\"])\n\"~/foo\"\n```\n\n#### other.ex\n\n```\nPath.join([\"foo\"])\n\"foo\"\n```\n\nCode blocks can have headings.","ref":"cheatsheet.html#code-with-headings"},{"type":"extras","title":"Long lines - Cheatsheet Example","doc":"```elixir\ndefmodule MyTracer do\n  def trace({:remote_function, _meta, module, name, arity}, env) do\n    IO.puts \"#{env.file}:#{env.line} #{inspect(module)}.#{name}/#{arity}\"\n    :ok\n  end\n\n  def trace(_event, _env) do\n    :ok\n  end\nend\n```\n\nLong lines show scrollbars.","ref":"cheatsheet.html#long-lines"},{"type":"extras","title":"Line wrapping - Cheatsheet Example","doc":"```elixir\ndefmodule MyTracer do\n  def trace({:remote_function, _meta, module, name, arity}, env) do\n    IO.puts \"#{env.file}:#{env.line} #{inspect(module)}.#{name}/#{arity}\"\n    :ok\n  end\n\n  def trace(_event, _env) do\n    :ok\n  end\nend\n```\n{: .wrap}\n\nAdd `wrap` to wrap long lines.","ref":"cheatsheet.html#line-wrapping"},{"type":"extras","title":"Lists - Cheatsheet Example","doc":"{: .col-2}","ref":"cheatsheet.html#lists"},{"type":"extras","title":"Bullet lists - Cheatsheet Example","doc":"- This is\n- a list\n- with a few items","ref":"cheatsheet.html#bullet-lists"},{"type":"extras","title":"Ordered lists - Cheatsheet Example","doc":"1. First\n2. Second\n3. Third\n\nAn extra paragraph after the list.","ref":"cheatsheet.html#ordered-lists"},{"type":"extras","title":"With headings and code links - Cheatsheet Example","doc":"#### Part 1\n\n- `is_atom/1`\n- `is_binary/1`\n- `is_number/1`\n\n#### Part 2\n\n- `length/1`\n- `elem/2`","ref":"cheatsheet.html#with-headings-and-code-links"},{"type":"extras","title":"List columns - Cheatsheet Example","doc":"","ref":"cheatsheet.html#list-columns"},{"type":"extras","title":"Six columns - Cheatsheet Example","doc":"{: .list-6}\n\n- One\n- Two\n- Three\n- Four\n- Five\n- Six\n- Seven\n- Eight\n- Nine\n- Ten\n- Eleven\n\nAdd `{: .list-6}` after the H3 title to make large lists.","ref":"cheatsheet.html#six-columns"},{"type":"extras","title":"Four columns - Cheatsheet Example","doc":"{: .list-4}\n\n- One\n- Two\n- Three\n- Four\n- Five\n- Six\n- Seven\n- Eight\n- Nine\n- Ten\n- Eleven\n\nAdd `{: .list-4}` after the H3 title to make large lists.","ref":"cheatsheet.html#four-columns"},{"type":"extras","title":"Full page - Cheatsheet Example","doc":"The default.","ref":"cheatsheet.html#full-page"},{"type":"extras","title":"Half width - Cheatsheet Example","doc":"{: .width-50}","ref":"cheatsheet.html#half-width"},{"type":"extras","title":"Avoid overly long lines - Cheatsheet Example","doc":"#### Time\n\n| Example         | Output                 |\n| ---             | ---                    |\n| `%H:%M`         | `23:05`                |\n| `%I:%M %p`      | `11:05 PM`             |\n\nAdd `{: .width-50}` after the H2 title to use only half width.","ref":"cheatsheet.html#avoid-overly-long-lines"},{"type":"extras","title":"Column left example - Cheatsheet Example","doc":"{: .col-2-left}","ref":"cheatsheet.html#column-left-example"},{"type":"extras","title":"One - Cheatsheet Example","doc":"```elixir\n# hello.exs\ndefmodule Greeter do\n  def greet(name) do\n    message = \"Hello, \" <> name <> \"!\"\n    IO.puts message\n  end\nend\n\nGreeter.greet(\"world\")\n```","ref":"cheatsheet.html#one"},{"type":"extras","title":"Two - Cheatsheet Example","doc":"```elixir\nuser = %{\n  name: \"John\",\n  city: \"Melbourne\"\n}\n```\n\n```elixir\nIO.puts \"Hello, \" <> user.name\n```","ref":"cheatsheet.html#two"},{"type":"extras","title":"Three - Cheatsheet Example","doc":"* Yet\n* Another\n* List","ref":"cheatsheet.html#three"},{"type":"extras","title":"Four - Cheatsheet Example","doc":"A grid, with 1/3 - 2/3 widths.","ref":"cheatsheet.html#four"},{"type":"extras","title":"Changelog","doc":"# Changelog","ref":"changelog.html"},{"type":"extras","title":"v0.37.0 (2025-02-05) - Changelog","doc":"Thanks to @liamcmitchell and @hichemfantar for the extensive contributions in this new release.\n\n  * Enhancements\n    * Optimize and parallelize module retriever, often leading to 20x-30x faster docs generation\n    * Considerably improve page loading times in the browser\n    * Allow customizing `search_data` for extra pages\n    * Use native style for scroll bars\n    * Enhance links between extras/pages/guides with padding and hover effects\n    * Go to latest goes to the same page if it exists, root otherwise\n    * Apply new style and layout for tabs\n    * Increase font-weight on sidebar on Apple machines/devices\n    * Improve accessibility across deprecation, links, and summaries\n    * Add compatibility to Erlang/OTP 28+\n    * Rely on the operating system monospace font for unified experience and better load times\n    * Introduce `\"exdoc:loaded\"` window event to track navigation\n    * Support for favicons\n\n  * Bug fixes\n    * Move action links out from heading tags","ref":"changelog.html#v0-37-0-2025-02-05"},{"type":"extras","title":"v0.36.1 (2024-12-24) - Changelog","doc":"* Enhancements\n    * Show a progress bar if navigation takes more than 300ms\n\n  * Bug fixes\n    * Fix dark mode styling on cheatsheets\n    * Ensure the sidebar closes on hosting navigation in mobile","ref":"changelog.html#v0-36-1-2024-12-24"},{"type":"extras","title":"v0.36.0 (2024-12-24) - Changelog","doc":"* Enhancements\n    * Use swup.js for navigation on hosted sites\n    * Support `:group` in documentation metadata for grouping in the sidebar\n    * Support `:default_group_for_doc` in configuration to set the default group for functions, callbacks, and types\n    * Add `--warnings-as-errors` flag to `mix docs`\n\n  * Bug fixes\n    * Fix typespec with `(...) -> any()`\n    * Do not trap `tab` commands in the search bar","ref":"changelog.html#v0-36-0-2024-12-24"},{"type":"extras","title":"v0.35.1 (2024-11-21) - Changelog","doc":"* Bug fixes\n    * Make sure symlinks are copied from assets directory\n    * Discard private functions documented by EDoc","ref":"changelog.html#v0-35-1-2024-11-21"},{"type":"extras","title":"v0.35.0 (2024-11-19) - Changelog","doc":"* Enhancements\n    * Store `proglang` in `searchdata.js`\n    * Allow searching for atoms inside backticks\n    * Add support for nominal types from Erlang/OTP 28\n    * Support a new `:redirects` option which allows configuring redirects in the sidebar\n    * Improve warning when referencing type from a private module\n    * Rename \"Search HexDocs package\" modal to \"Go to package docs\"\n    * Support built-in Erlang/OTP apps in \"Go to package docs\"\n\n  * Bug fixes\n    * Switch anchor `title` to `aria-label`\n    * Convert admonition blockquotes to sections for screen reader users\n    * Fix code copy buttons within tabsets","ref":"changelog.html#v0-35-0-2024-11-19"},{"type":"extras","title":"v0.34.2 (2024-07-08) - Changelog","doc":"* Enhancements\n    * Allow anchors on function and callback autolinks\n\n  * Bug fixes\n    * Make module attributes searchable without leading @\n    * Make Mod.fun pairs searchable without the arity\n    * Do not emit warnings on unary plus in typespecs\n    * Add top margin to nested module prefix in sidebar","ref":"changelog.html#v0-34-2-2024-07-08"},{"type":"extras","title":"v0.34.1 (2024-06-30) - Changelog","doc":"* Enhancements\n    * Add a `v` shortcut to open/focus the version select\n    * Compatibility fixes for Elixir v1.17 and Erlang/OTP 27+\n\n  * Bug fixes\n    * Do not crash on unknown media types in assets during EPUB generation\n    * Fix slight shift on search bar input during focus\n    * Avoid unwanted showing/hiding of search bar on mobile when scrolling","ref":"changelog.html#v0-34-1-2024-06-30"},{"type":"extras","title":"v0.34.0 (2024-05-30) - Changelog","doc":"This release requires Elixir v1.13.\n\n  * Enhancements\n    * Allow several assets to be copied by passing a map to `:assets`\n    * Improve compatibility when hosting ExDoc on a platform that strips `.html`\n\n  * Bug fixes\n    * Link to the latest version of Erlang/OTP docs\n\n  * Deprecations\n    * Deprecate passing a binary to `:assets`","ref":"changelog.html#v0-34-0-2024-05-30"},{"type":"extras","title":"v0.33.0 (2024-05-21) - Changelog","doc":"* Enhancements\n    * Keep the sidebar light in light mode","ref":"changelog.html#v0-33-0-2024-05-21"},{"type":"extras","title":"v0.32.2 (2024-05-10) - Changelog","doc":"* Enhancements\n    * Allow the modal to close when we click outside the modal content\n\n  * Bug fixes\n    * Fix indentation of -spec/-type in Erlang\n    * Fix Mix task autolink for tasks with underscores\n    * Avoid conflicts between custom headers with tooltips/modals","ref":"changelog.html#v0-32-2-2024-05-10"},{"type":"extras","title":"v0.32.1 (2024-04-12) - Changelog","doc":"* Bug fixes\n    * Add version dropdown back on hexdocs.pm\n    * Improve search input styling and scrolling","ref":"changelog.html#v0-32-1-2024-04-12"},{"type":"extras","title":"v0.32.0 (2024-04-10) - Changelog","doc":"* Enhancements\n    * Add the ability to see previews during autocompletion\n    * Remove serif font for content and prefer using the operating system font instead\n    * Allow the search bar to be focused at any moment\n    * Make functions acceptable for `:skip_undefined_reference_warnings_on`\n    * Make functions acceptable for `:skip_code_autolink_to`\n    * Allow using meta tags to disable autocompletion and configure the full text search\n\n  * Bug fixes\n    * Fix blockquote padding inside tabset on small screens\n    * Consistently index h2 and h3 headers","ref":"changelog.html#v0-32-0-2024-04-10"},{"type":"extras","title":"v0.31.2 (2024-03-05) - Changelog","doc":"* Enhancements\n    * Add `equiv` handling for types and callbacks for Erlang\n    * Add cmd-k/ctrl-k shortcut to focus searchbar\n    * Use dark backgrounds for admonition blocks in dark theme\n    * Autolink .cheatmd files\n    * Warn when extra link targets an application not in dependencies\n    * Add support for `before_closing_footer_tag`\n\n  * Bug fixes\n    * Fix sidebar toggle flickering on page load\n    * Fix background color inside code snippets with no language in dark mode\n    * Hide search bar and background layer on print\n    * Use blue links for Erlang\n    * Fix logo not declared in EPUB's OPF manifest\n    * Escape URIs and titles in EPUB\n    * Fix URL slug not updating on anchor clicks","ref":"changelog.html#v0-31-2-2024-03-05"},{"type":"extras","title":"v0.31.1 (2024-01-11) - Changelog","doc":"* Enhancements\n    * Make the sidebar horizontally resizable\n    * Show the sidebar button and search bar on scroll up on mobile devices\n    * More improvements to Erlang/OTP 27 support\n    * Document that `source_url_pattern` can be a fun\n    * Support `m:Module#anchor`","ref":"changelog.html#v0-31-1-2024-01-11"},{"type":"extras","title":"v0.31.0 (2023-12-11) - Changelog","doc":"* Enhancements\n    * Allow searching atoms, module attributes, and words finishing with `?` and `!`\n    * Support upcoming Erlang/OTP 27 documentation format\n    * Include prebuilt binaries on every release\n    * Add borders dividing table rows in rendered content\n    * Add accurate warnings for missing docs from Elixir v1.16+\n    * Support `e:dep:some-page.md` for explicitly linking to a page in a package\n    * Support `m:SomeModule` for explicitly linking to a module\n    * Add `noindex` meta tag to 404 and Search pages\n    * Move search to the main content so we can display more results\n    * Warn when referencing functions, types, and callbacks from filtered out modules\n\n  * Bug fixes\n    * Fix search for words with hyphens in them\n    * Fix search for contents inside EEx interpolation","ref":"changelog.html#v0-31-0-2023-12-11"},{"type":"extras","title":"v0.30.9 (2023-10-20) - Changelog","doc":"* Bug fixes\n    * Fix a scenario where invalid assets would be generated\n\n  * Enhancements\n    * Add admonition EPUB styles","ref":"changelog.html#v0-30-9-2023-10-20"},{"type":"extras","title":"v0.30.8 (2023-10-17) - Changelog","doc":"* Bug fixes\n    * Fix regression in umbrella applications","ref":"changelog.html#v0-30-8-2023-10-17"},{"type":"extras","title":"v0.30.7 (2023-10-15) - Changelog","doc":"* Bug fixes\n    * Do not crash on EDoc type annotations\n    * Do not crash on functions without name\n    * Handle remote types in records\n    * Fix scrolling to top on iOS\n    * Fix invalid output markup for “hover link” headings\n\n  * Enhancements\n    * Support any String.Chars as the extra page name\n    * Improve screen reader accessibility\n    * Add `:skip_code_autolink_to` option","ref":"changelog.html#v0-30-7-2023-10-15"},{"type":"extras","title":"v0.30.6 (2023-08-25) - Changelog","doc":"* Enhancements\n    * Extract title from Markdown file when preceded with comments\n    * Improve focus navigation in notebooks","ref":"changelog.html#v0-30-6-2023-08-25"},{"type":"extras","title":"v0.30.5 (2023-08-12) - Changelog","doc":"* Bug fixes\n    * Fix style for code in headers\n    * Fix search data generation for Erlang/OTP","ref":"changelog.html#v0-30-5-2023-08-12"},{"type":"extras","title":"v0.30.4 (2023-08-03) - Changelog","doc":"* Bug fixes\n    * Fix style for anchors in headers","ref":"changelog.html#v0-30-4-2023-08-03"},{"type":"extras","title":"v0.30.3 (2023-07-15) - Changelog","doc":"* Enhancements\n    * Compress search index before storing in local storage\n\n  * Bug fixes\n    * Fix styling for headers on cheatsheets and small screens","ref":"changelog.html#v0-30-3-2023-07-15"},{"type":"extras","title":"v0.30.2 (2023-07-11) - Changelog","doc":"* Bug fixes\n    * Fix escaping in `search_data.json`\n    * Skip vega-lite code blocks in `search_data.json`","ref":"changelog.html#v0-30-2-2023-07-11"},{"type":"extras","title":"v0.30.1 (2023-07-07) - Changelog","doc":"* Bug fixes\n    * Fix styling for headers on cheatsheets and small screens","ref":"changelog.html#v0-30-1-2023-07-07"},{"type":"extras","title":"v0.30.0 (2023-07-07) - Changelog","doc":"* Enhancements\n    * Support tabsets (see the README for more information)\n    * Improve search results and indexing by storing more data and metadata\n    * Warn on invalid references in links\n    * Strike-through deprecated items on autocompletion\n    * Add source URL link to API reference page\n    * Allow multiple extra files with the same name by generating unique names in case of conflicts\n\n  * Bug fixes\n    * Fix rendering of large code blocks in admonition texts\n    * Do not log errors on module mismatch in case-insensitive file systems","ref":"changelog.html#v0-30-0-2023-07-07"},{"type":"extras","title":"v0.29.4 (2023-03-29) - Changelog","doc":"* Bug fixes\n    * Fix sidebar element with no children taking additional padding\n    * Fix elements being rendered too thick on macOS\n    * Fix rendering of HTML elements inside tooltips","ref":"changelog.html#v0-29-4-2023-03-29"},{"type":"extras","title":"v0.29.3 (2023-03-17) - Changelog","doc":"* Enhancements\n    * Propagate `:since` metadata from modules\n    * Add support for MFAs and maps in `before_closing_body_tag` and `before_closing_head_tag`\n\n  * Bug fixes\n    * Improve font consistency across different OSes\n    * Keep language class on livebook output code block\n    * Ensure switches have higher precedence than config","ref":"changelog.html#v0-29-3-2023-03-17"},{"type":"extras","title":"v0.29.2 (2023-03-02) - Changelog","doc":"* Enhancements\n    * Improvements to cheatsheets spacing\n    * Improvements to cheatsheets print\n    * Include sections of modules and extras in search suggestions\n    * Make sidebar links full-width and add hover states\n    * Improve clickable area of sidebar tabs\n    * Improve contrast on sidebar\n\n  * Bug fix\n    * Add media type for .license files for epub\n    * Fix overscroll on the sidebar\n    * Focus search input immediately after keyboard shortcut\n    * Don't attempt parsing code blocks that don't look like modules\n    * Fix visited link color in admonition blocks","ref":"changelog.html#v0-29-2-2023-03-02"},{"type":"extras","title":"v0.29.1 (2022-11-21) - Changelog","doc":"* Enhancements\n    * Add optional function annotations\n    * Support media print on stylesheets\n    * Add download ePub link to footer\n    * Support extras for Erlang\n    * Add tooltip to functions on sidebar\n    * Disable spellcheck and autocorrect on search input\n\n  * Bug fix\n    * Special handle functions called `record/*` in Erlang\n\n  * Deprecations\n    * Rename `:groups_for_functions` to `:groups_for_docs`","ref":"changelog.html#v0-29-1-2022-11-21"},{"type":"extras","title":"v0.29.0 (2022-10-19) - Changelog","doc":"* Enhancements\n    * Support cheatsheets as `.cheatmd` files\n\n  * Bug fix\n    * Collapse sidebar when resizing page even if stored in the session as opened","ref":"changelog.html#v0-29-0-2022-10-19"},{"type":"extras","title":"v0.28.6 (2022-10-13) - Changelog","doc":"* Enhancements\n    * Add Elixir special punctuation ! and ? to natural sort\n    * Add night mode to settings pane\n    * Support --proglang in mix docs\n    * Save sidebar state per session\n    * Distinguish output code blocks in Livebooks\n\n  * Bug fixes\n    * Prevent sidebar button scrolling out of view\n    * Prevent unreadable text when using inline code with admonition headers","ref":"changelog.html#v0-28-6-2022-10-13"},{"type":"extras","title":"v0.28.5 (2022-08-18) - Changelog","doc":"* Enhancements\n    * Do not preserve spaces from spec declaration in signature rendering\n    * Index hyphens in search\n    * Index `@` in search\n    * Change minimal package search length to 2\n\n  * Bug fixes\n    * Remove extra `term()` argument at start of `@macrocallback`","ref":"changelog.html#v0-28-5-2022-08-18"},{"type":"extras","title":"v0.28.4 (2022-04-28) - Changelog","doc":"* Enhancements\n    * Add a toast when changing theme via keyboard\n    * Automatically convert `.livemd` links to `.html` ones\n    * Show programming language in HTML footer\n\n  * Bug fixes\n    * Properly escape `%/2` special form\n    * Improve ranking of exact-matching modules in search","ref":"changelog.html#v0-28-4-2022-04-28"},{"type":"extras","title":"v0.28.3 (2022-03-23) - Changelog","doc":"* Enhancements\n    * Include page titles in autocomplete suggestions\n    * Allow theme to be set to \"System\" version\n    * Remove \"Specs\" heading and render full typespecs\n    * Support for `source_url_pattern` in config being a function\n\n  * Bug fixes\n    * Adjustments for blockquotes and admonition blocks in dark mode\n    * Fix module sorting when a list of dirs is provided\n    * Consider casing of letters when sorting items in the menu, summary, function list, etc","ref":"changelog.html#v0-28-3-2022-03-23"},{"type":"extras","title":"v0.28.2 (2022-02-23) - Changelog","doc":"* Bug fixes\n    * Fix links and code tags in admonition text blocks for dark mode","ref":"changelog.html#v0-28-2-2022-02-23"},{"type":"extras","title":"v0.28.1 (2022-02-20) - Changelog","doc":"* Enhancements\n    * Add support for admonition text blocks\n    * Improve accessibility for light and dark themes\n\n  * Bug fixes\n    * Ensure that `mix docs --open` works on Windows\n    * Ensure search tokenizer also splits on underscore\n    * Fix false warnings about missing types when running ExDoc in escript mode\n    * Don't navigate when clicking the current page","ref":"changelog.html#v0-28-1-2022-02-20"},{"type":"extras","title":"v0.28.0 (2022-01-24) - Changelog","doc":"ExDoc v0.28.0 requires Elixir v1.11+.\n\n  * Enhancements\n    * Use custom scrollbar in the sidebar\n    * Keep hamburger absolute to the opened sidebar\n    * Support `--open` flag on `mix docs`\n    * The copy button now only copies selectable content\n\n  * Bug fixes\n    * Make sure filename configuration in `:extras` is used across links\n    * Ensure all `extras` pages have a title generated\n    * Fix margin on 3rd level headers and beyond\n    * Ensure a task that defines callbacks is still listed as a task","ref":"changelog.html#v0-28-0-2022-01-24"},{"type":"extras","title":"v0.27.3 (2022-01-12) - Changelog","doc":"* Bug fixes\n    * Make HexDocs search case insensitive\n    * Improve sidebar open/close animation","ref":"changelog.html#v0-27-3-2022-01-12"},{"type":"extras","title":"v0.27.2 (2022-01-11) - Changelog","doc":"* Bug fixes\n    * Fix version dropdown when hosted on HexDocs\n    * Fix tooltips\n    * Fix JavaScript error when Hex package information is not available","ref":"changelog.html#v0-27-2-2022-01-11"},{"type":"extras","title":"v0.27.1 (2022-01-11) - Changelog","doc":"* Bug fixes\n    * Several usability fixes on the new layout\n    * Keep page ordering","ref":"changelog.html#v0-27-1-2022-01-11"},{"type":"extras","title":"v0.27.0 (2022-01-11) - Changelog","doc":"* Enhancements\n    * Introduce new sidebar design\n    * Add `--quiet` option to CLI\n    * Support multiple formatters in the CLI\n    * Show structs as `%Struct{}` instead of `__struct__` in the sidebar\n    * Point Erlang links to `www.erlang.org` instead of `erlang.org`\n    * Improvements to the night mode and styling","ref":"changelog.html#v0-27-0-2022-01-11"},{"type":"extras","title":"v0.26.0 (2021-11-21) - Changelog","doc":"* Backwards incompatible changes\n    * `:filter_prefix` has been renamed to `:filter_modules` and supports anonymous functions\n    * `:source_ref` now defaults to `\"main\"`\n    * Dropped support for smartypants in Markdown\n\n  * Bug fixes\n    * Do not warn on links to sections\n\n  * Enhancements\n    * Add copy button to code snippets\n    * Add `translate=\"no\"` to the relevant attributes to improve interoperability with automatic translation tools\n    * Support optional module annotations\n    * Introduce a settings modal to group most of configuration\n    * Allow customizing the Livebook expansion URL\n    * Provide documentation on how to render plugins such as Katex, VegaLite, and Mermaid","ref":"changelog.html#v0-26-0-2021-11-21"},{"type":"extras","title":"v0.25.5 (2021-10-20) - Changelog","doc":"* Bug fixes\n    * Do not duplicate API Reference title\n    * Update assets for Livebook badge functionality","ref":"changelog.html#v0-25-5-2021-10-20"},{"type":"extras","title":"v0.25.4 (2021-10-20) - Changelog","doc":"* Enhancements\n    * Add source link to pages in `:extras`\n    * Add \"Run in Livebook\" badge to `.livemd` pages in `:extras`\n\n  * Bug fixes\n    * Do not generate entries for private Erlang functions\n    * Do not trim `?` and `!` from Elixir tokens on search\n\n  * Incompatible changes\n    * Remove unused `:source_root` option","ref":"changelog.html#v0-25-4-2021-10-20"},{"type":"extras","title":"v0.25.3 (2021-09-21) - Changelog","doc":"* Enhancements\n    * Track user preference for sidebar state\n\n  * Bug fixes\n    * Do not double escape page titles on the sidebar\n    * Do not fail when documenting cover compiled modules\n    * Don't crash upon doc chunks for unknown beam languages","ref":"changelog.html#v0-25-3-2021-09-21"},{"type":"extras","title":"v0.25.2 (2021-09-02) - Changelog","doc":"* Enhancements\n    * Add support for Livebook's `.livemd` Markdown files\n    * Preload all applications starting with `makeup_` before doc generation\n    * Add Hex package config and display \"Find on Hex\" footer links","ref":"changelog.html#v0-25-2-2021-09-02"},{"type":"extras","title":"v0.25.1 (2021-08-02) - Changelog","doc":"* Enhancements\n    * Supporting grouping of callbacks\n    * Use shell lexer for code blocks with no language and starting with `$ `\n\n  * Bug fixes\n    * Fix generating type signatures with maps\n    * Skip Erlang modules that have empty docs\n    * Skip Erlang functions that have empty docs\n    * Fix accidentally showing shape of opaque types","ref":"changelog.html#v0-25-1-2021-08-02"},{"type":"extras","title":"v0.25.0 (2021-07-20) - Changelog","doc":"* Enhancements\n    * Handle remote types when generating signatures, e.g. `@callback callback1(GenServer.options())` becomes `callback1(options)`\n    * Support Markdown processor options\n    * Add `--paths` command line argument to prepend directories to the code path when generating docs\n    * Make shell prompt, `$ `, not selectable for `shell`, `sh`, `bash` and `zsh` code blocks\n\n  * Bug fixes\n    * Fix custom links to undefined/hidden references\n    * Fix generating external links with `:deps` configuration\n    * Add ellipsis to more sections\n\n  * Backwards incompatible changes\n    * Remove function landing pages","ref":"changelog.html#v0-25-0-2021-07-20"},{"type":"extras","title":"v0.24.2 (2021-04-06) - Changelog","doc":"* Enhancements\n    * Support stepped range syntax\n\n  * Bug fixes\n    * Add spaces on paragraph endings for search results\n    * Fix bug defining app name in config\n    * Fix rendering void elements (` ` etc)","ref":"changelog.html#v0-24-2-2021-04-06"},{"type":"extras","title":"v0.24.1 (2021-03-22) - Changelog","doc":"* Bug fixes\n    * Fix generating function landing pages","ref":"changelog.html#v0-24-1-2021-03-22"},{"type":"extras","title":"v0.24.0 (2021-03-16) - Changelog","doc":"* Enhancements\n    * Drop jQuery and refactor JavaScript codebase\n    * Remove highlight.js in favour of migration to Makeup\n    * Change autolink to return both path and hash for the current module\n    * Add next/previous at the end of extra pages\n    * Improve search input blur handling\n    * Update erlang.org/man URL\n    * Add function landing page\n\n  * Bug fixes\n    * Ignore extensions when generating external links\n    * Fix autolink to handle URIs with arbitrary scheme part without warning\n    * Fix undefined reference warning for typespecs\n    * Fix search click behavior when a suggestion refers the current page\n    * Don't crash when we can't format spec\n    * Fix HTML escaping","ref":"changelog.html#v0-24-0-2021-03-16"},{"type":"extras","title":"v0.23.0 (2020-10-12) - Changelog","doc":"Requires Elixir v1.10.\n\n  * Enhancements\n    * Improve warnings on broken references\n    * Support Elixir v1.12-dev\n\n  * Bug fixes\n    * Respect deps config in autolink\n    * Fix html escaping in the sidebar entries\n    * Fix retrieving specs for macros with `when`\n    * Raise if none of :name or :app are found in mix.exs\n    * Don't crash on code blocks like \"A.b.C\"","ref":"changelog.html#v0-23-0-2020-10-12"},{"type":"extras","title":"v0.22.6 (2020-09-16) - Changelog","doc":"* Bug fixes\n    * Properly fix CSS bug on headings\n    * Add expansion arrow to sections on sidebar","ref":"changelog.html#v0-22-6-2020-09-16"},{"type":"extras","title":"v0.22.5 (2020-09-13) - Changelog","doc":"* Bug fixes\n    * Fix CSS bug on headings","ref":"changelog.html#v0-22-5-2020-09-13"},{"type":"extras","title":"v0.22.4 (2020-09-12) - Changelog","doc":"* Enhancements\n    * Improve accessibility and add aria labels\n    * Show different title and message for a empty search value","ref":"changelog.html#v0-22-4-2020-09-12"},{"type":"extras","title":"v0.22.3 (2020-07-25) - Changelog","doc":"* Bug fixes\n    * [HTML+EPUB] Remove overlapping functions from defaults\n    * [HTML] Don't show tooltip for module sections and non-html files\n    * [HTML] Make sure tooltips work with escape ids.","ref":"changelog.html#v0-22-3-2020-07-25"},{"type":"extras","title":"v0.22.2 (2020-07-20) - Changelog","doc":"* Enhancements\n    * [HTML+EPUB] Add support for path dependent markdown autolink (`feeddc1`)\n    * [HTML+EPUB] Improve auto-linking to callbacks and types (`12c0a01`)\n    * [HTML+EPUB] Replace ` ` with `  ` when it represents keys to be hit (`bd2b8df`)\n    * [HTML] Hide sidebar-over-content on click/tap outside it (`b050775`)\n    * [HTML] Redirect to correct file when changing version (`0f6f24b`)\n    * [mix docs] Allow files with no extension in extra files (`26b93b6`)\n    * [mix docs] Link to siblings in an umbrella (`b0d6fdd`)\n    * [mix docs] Switch to `earmark_parser`. Run `mix deps.unlock --unused` to remove the now\n      unused `earmark` dependency. (`021c772`)\n\n  * Bug fixes\n    * [HTML+EPUB] Bring back auto-linking to Kernel and Kernel.SpecialForms (`fa174eb`)\n    * [HTML+EPUB] Escape HTML special characters in signature (`5fed479`)\n    * [HTML+EPUB] Fix auto-linking `./2` and `../2` (`2e40acb`)\n    * [HTML+EPUB] Fix list of basic types to auto-link (`6df4a3b`)\n    * [HTML+EPUB] Make HTML valid (`1187ace`)\n    * [HTML] Escape HTML special characters in sidebar (`d26ca71`)\n    * [HTML] Fix keyboard shortcuts on non US keyboard layouts (`829c4ee`)\n    * [HTML] Fix text overflow in sidebar (`a4ff547`)\n    * [HTML] Handle snake case terms in search results (`d511d55`)\n    * [mix docs] Don't crash on markdown that triggers warning (`e7cb79c`)","ref":"changelog.html#v0-22-2-2020-07-20"},{"type":"extras","title":"v0.22.1 (2020-05-19) - Changelog","doc":"* Bug fixes\n    * [mix docs] Depend on earmark `~> 1.4.0`\n    * [mix docs] Don't crash on comments in markdown\n    * [mix docs] Don't crash on HTML in markdown","ref":"changelog.html#v0-22-1-2020-05-19"},{"type":"extras","title":"v0.22.0 (2020-05-11) - Changelog","doc":"* Enhancements\n    * [EPUB] Add epub to the default formatters\n    * [HTML+EPUB] Move specs out of signature\n    * [HTML+EPUB] Auto-link \"erlang\" types & callbacks\n    * [HTML+EPUB] Auto-link \"erlang\" modules in custom links\n    * [mix docs] Warn on broken references in dependencies (e.g. `` `String.upcase/9` ``)\n    * [escript] Add `--app`\n    * [HTML+EPUB] Auto-link to extras (e.g. `[foo](foo.md)`)\n    * [mix docs] Undefined references warning now includes the filename\n    * [mix docs] `:skip_undefined_reference_warnings_on` now also accepts a filename\n    * [HTML+EPUB] Display moduledoc headings in the sidebar\n\n  * Bug fixes\n    * [HTML] Fix hidden text selection, hide tooltips for details link\n    * [HTML+EPUB] Fix function name sorting (group operators together)\n    * [HTML+EPUB] Fix displaying nested modules\n\n  * Backwards incompatible changes\n    * [mix docs] Remove built-in support for cmark markdown processor\n    * [mix docs] Replace `ExDoc.Markdown.to_html/2` with `to_ast/2`\n    * [HTML+EPUB] Remove auto-linking for local calls to Kernel & Kernel.SpecialForms,\n      use fully qualified calls instead. (e.g. replace `` `==/2` `` with `` `Kernel.==/2` ``.)\n    * [mix docs] `:skip_undefined_reference_warnings_on` no longer accepts extras id, use\n      extras filename instead.","ref":"changelog.html#v0-22-0-2020-05-11"},{"type":"extras","title":"v0.21.3 - Changelog","doc":"* Enhancements\n    * [HTML] Make \"Exceptions\" a module sub-grouping instead of a top-level group\n    * [HTML] Automatically group deprecated modules\n    * [HTML] Rely on `prefers-color-scheme` w/o night mode set\n    * [HTML] Boost title on search results, add fun/arity to title\n    * [mix docs] Initial work on support for multiple languages\n\n  * Bug fixes\n    * [HTML] Many improvements to the search engine\n    * [mix docs] Link to callback docs instead of copying them","ref":"changelog.html#v0-21-3"},{"type":"extras","title":"v0.21.2 - Changelog","doc":"* Enhancements\n    * [HTML] Add hardcoded packages to the quick-switch search results\n    * [HTML] Filter out packages without docs on HexDocs in quick-switch\n    * [HTML+EPUB] Support autolinking for multiple arities\n    * [mix docs] Avoid deprecation warnings on more recent earmark versions\n    * [mix docs] Warn on unavailable local functions\n    * [mix docs] Make invalid index redirect warning case-sensitive\n    * [mix docs] Ignore non-Elixir modules when missing chunk\n\n  * Bug fixes\n    * [HTML+EPUB] Do not create a custom link when destination does not exist\n    * [EPUB] Hide screen reader elements","ref":"changelog.html#v0-21-2"},{"type":"extras","title":"v0.21.1 - Changelog","doc":"* Bug fixes\n    * [HTML] Make sure package selector can be reopened after closed with `ESC`\n    * [HTML] Ensure tooltip pages can be cached\n    * [HTML] Support large version numbers on the version dropdown\n    * [mix docs] Raise nice exception for missing ExDoc.Config","ref":"changelog.html#v0-21-1"},{"type":"extras","title":"v0.21.0 - Changelog","doc":"* Enhancements\n    * [HTML] Add support for reference popovers\n    * [HTML] Provide a \"g\" shortcut to Go To a Hexdocs package (with autocomplete)\n    * [HTML] Detect if browser prefers night mode\n    * [EPUB] Add support for covers and the authors field\n\n  * Bug fixes\n    * [HTML+EPUB] Ensure that link headers generate unique IDs\n    * [HTML+EPUB] Sort structs fields so field names are always ordered\n    * [HTML+EPUB] Do not strip \"Elixir.\" prefix from module names\n    * [HTML] Support URLs with non-HTML safe characters\n    * [EPUB] Fix table of contents without groups","ref":"changelog.html#v0-21-0"},{"type":"extras","title":"v0.20.2 - Changelog","doc":"* Enhancements\n    * Add \"mix \" prefix to Mix tasks\n\n  * Bug fixes\n    * Improve scrolling on Safari\n    * Prevent text casing of codes\n    * Do not remove stop words from search and make sure function names are searchable in isolation\n    * Reduce the size of the search metadata\n    * Remove outline on focus and keep width in version dropdown\n    * Do not fail if we can't persist index","ref":"changelog.html#v0-20-2"},{"type":"extras","title":"v0.20.1 - Changelog","doc":"* Bug fixes\n    * Hide the spinner when no term is searched\n    * Use `?` for the shortcut hint text\n    * Improve style of the version dropdown","ref":"changelog.html#v0-20-1"},{"type":"extras","title":"v0.20.0 - Changelog","doc":"* Enhancements\n    * Rework the search bar to provide autocompletion\n    * Provide full-text search\n    * Automatically generate documentation for `defdelegate` definitions (requires Elixir v1.8+)\n    * Provide keyboard shortcuts (press `?` to see all available outputs) or click the link at the bottom of the page\n    * Add support for versions dropdown to the HTML sidebar. This requires adding a `docs_config.js` (also configurable) that sets a `versionNodes` JavaScript variable.\n    * Improve mouseover titles on sidebar navigation\n\n  * Bug fixes\n    * Do not hide structs in type/callback summary signatures\n    * No longer require double click to open up a sidebar on Mobile Safari\n    * Keep trailing periods in summaries\n    * Fix typespec `arg` number to start from 1 instead of 0","ref":"changelog.html#v0-20-0"},{"type":"extras","title":"v0.19.3 - Changelog","doc":"* Enhancements\n    * Include a \"goto\" link on mouseover for expandable menu items\n\n  * Bug fixes\n    * Always expand menu items, even if has a single child\n    * Fix sidebar bottom margin on Firefox\n    * Fix anchor links sometimes not working by moving JS to HTML head\n    * Unify code styling for makeup and hljs\n    * Do not replace the content of custom links pointing to Elixir modules\n    * Remove border-left on deprecated to not mistake it with a heading","ref":"changelog.html#v0-19-3"},{"type":"extras","title":"v0.19.2 - Changelog","doc":"* Enhancements\n    * Allow logo in SVG extension\n    * Allow functions to be grouped based on metadata\n    * Allow api-reference.html page to be disabled\n    * Allow nesting of modules by prefix\n    * Autolink `mix help TASK`\n    * Warn on undefined remote functions from project's docs\n\n  * Bug fixes\n    * Sort function names alphabetically in the sidebar\n    * Fix search input color\n    * Disable earmark smartypants option","ref":"changelog.html#v0-19-2"},{"type":"extras","title":"v0.19.1 - Changelog","doc":"* Enhancements\n    * Update CSS styles\n    * Remove sourcemaps from package","ref":"changelog.html#v0-19-1"},{"type":"extras","title":"v0.19.0 - Changelog","doc":"This release requires Elixir v1.7 and later. For earlier Elixir versions, use ExDoc ~> 0.18.0.\n\n  * Enhancements\n    * Do not select \"iex>\" when selecting code samples\n    * Use makeup to perform ELixir's syntax highlighting (other languages still use highlight.js)\n    * Use `[rel=\"noopener\"]` on external links\n    * Link directly to page if sidebar item has no subitems\n    * Autolink Kernel and Kernel functions and special forms with shorthands (for example, only `is_atom/1` is necessary)\n    * Trim EEx contents to reduce HTML size\n    * Allow apps to be excluded from umbrella app docs\n\n  * Bug fixes\n    * Exclude types with `@typedoc false` from the docs\n    * Make sure autolink considers the longest matching dependency name in case of shared prefixes","ref":"changelog.html#v0-19-0"},{"type":"extras","title":"v0.18.3 - Changelog","doc":"* Bug fix\n    * Fix formatting of typespecs causing errors\n    * Update jQuery\n    * Properly remove underscore from typespec links","ref":"changelog.html#v0-18-3"},{"type":"extras","title":"v0.18.2 - Changelog","doc":"* Enhancements\n    * Improve documentation pages for printing\n    * Autolink Kernel, Kernel.SpecialForms, and built-in types\n    * Annotate opaque types\n    * Add vertical-align:top to tables\n    * Allow module-function-arity references in links\n    * Remove underscore from view source link\n    * Run code formatter on typespecs (if one is available)\n    * Make night mode switch link more obvious","ref":"changelog.html#v0-18-2"},{"type":"extras","title":"v0.18.1 - Changelog","doc":"* Bug fixes\n    * Include missing formatter files","ref":"changelog.html#v0-18-1"},{"type":"extras","title":"v0.18.0 - Changelog","doc":"* Enhancements\n    * No longer strip empty parens from types\n    * Provide more extension point for markdown processors\n    * Remove assets from priv since they are now embedded at compile time\n\n  * Backwards incompatible changes\n    * Remove built-in support for hoedown markdown processor\n    * No longer add favicon when logo option is present (this was added in 0.17.0 but it was reported the logo almost never fits as a favicon)","ref":"changelog.html#v0-18-0"},{"type":"extras","title":"v0.17.1 - Changelog","doc":"* Bug fixes\n    * Fix broken search caused by outdated JavaScript files","ref":"changelog.html#v0-17-1"},{"type":"extras","title":"v0.17.0 - Changelog","doc":"* Enhancements\n    * Allow modules to be grouped on the sidebar with the `:groups_for_modules` option\n    * Allow extras to be grouped on the sidebar with the `:groups_for_extras` option\n\n  * Backwards incompatible changes\n    * The previous `:group` option that could be specified for each entry in `:extras` is no longer supported\n    * No longer add a specific section for \"Protocols\". If you would like to segregate the protocols in your application, use the new `:groups_for_modules` functionality","ref":"changelog.html#v0-17-0"},{"type":"extras","title":"v0.16.4 - Changelog","doc":"* Enhancements\n    * Generate favicon link if a logo is available\n\n  * Bug fixes\n    * Do not version epub filename as the doc directory is likely already versioned","ref":"changelog.html#v0-16-4"},{"type":"extras","title":"v0.16.3 - Changelog","doc":"* Enhancements\n    * Make sure its own search.html page and provide history\n    * Generate source maps only if the `--debug` flag is given\n    * Users can now add custom HTML before the closing head tag and the closing body tag\n    * Highlight the target function/macro/type/callback when clicked\n\n  * Bug fixes\n    * Remove extra `term()` argument at start of macro spec\n    * Add unencoded link target for functions with special chars to cope with different behaviour in browsers","ref":"changelog.html#v0-16-3"},{"type":"extras","title":"v0.16.2 - Changelog","doc":"* Enhancements\n    * Link ` ` headers as well\n    * Add border to code tag\n  * Bug fixes\n    * Fix sidebar on mobile devices","ref":"changelog.html#v0-16-2"},{"type":"extras","title":"v0.16.1 - Changelog","doc":"* Bug fixes\n    * Fix hover icons coloring","ref":"changelog.html#v0-16-1"},{"type":"extras","title":"v0.16.0 - Changelog","doc":"* Enhancements\n    * Separate tasks into \"Mix Tasks\" in sidebar\n    * Add types to the search results\n    * Improve accessibility\n\n  * Bug fixes\n    * Strip nesting HTML tags in h2 headers\n    * Remove the old search results after every new search attempt","ref":"changelog.html#v0-16-0"},{"type":"extras","title":"v0.15.1 - Changelog","doc":"* Bug fixes\n    * Improve project name wrapping on HTML\n    * Properly set link in types with parameter\n    * Fix ExDoc.CLI.main/2 to keep --source-ref on Elixir v1.4\n    * Do not fail if localStorage is not available","ref":"changelog.html#v0-15-1"},{"type":"extras","title":"v0.15.0 - Changelog","doc":"* Enhancements\n    * Closing the search takes you to where you were in the previous page\n    * Handle `__struct__/0` by displaying the struct instead\n    * Warn when redirecting to a non-existent file\n    * List both functions and macros under \"Functions\"\n    * Automatically detect GitLab source URL patterns\n\n  * Bug fixes\n    * Break long specs into lines\n    * Fix the initial state of the sidebar hamburger\n    * Do not error when abstract code is missing\n    * Properly link to erlang lib dirs\n\n  * Backwards incompatible changes\n    * No longer support Pandoc\n    * Require Earmark 1.1","ref":"changelog.html#v0-15-0"},{"type":"extras","title":"v0.14.5 - Changelog","doc":"* Enhancements\n    * Allow ExDoc to work as an escript","ref":"changelog.html#v0-14-5"},{"type":"extras","title":"v0.14.4 - Changelog","doc":"* Enhancements\n    * Point to Elixir docs on hexdocs.pm\n    * Many improvements to layout and styling of EPUB formatter\n    * Support multiple formatters to be configured on `mix.exs`\n    * Also digest `sidebar_items.js`\n    * Force parentheses on type signature to remove ambiguity\n    * Generate top-level docs for an umbrella project\n    * Searching on mobile closes menu when the Enter key is hit","ref":"changelog.html#v0-14-4"},{"type":"extras","title":"v0.14.3 - Changelog","doc":"* Enhancements\n    * Support the `:assets` option that automatically copies all entries in the given directory to `doc/assets`\n    * Remove numbering on Extras subheaders from sidebar\n    * Pass file and line information to markdown formatters for better warnings\n    * Allow extra pages to be grouped together under a given heading\n    * Generate ids for default name/arity pairs so they can be linked (both remotely and locally)\n\n  * Bug fixes\n    * Fix autolink for functions containing `%`, `{`, `}` or uppercase characters in the name","ref":"changelog.html#v0-14-3"},{"type":"extras","title":"v0.14.2 - Changelog","doc":"* Enhancements\n    * Automatically generate documentations links to any of your dependencies (by default links to hexdocs.pm but allows the URL to be configured)\n    * Allow documentation to be generated to Erlang modules\n\n  * Bug fixes\n    * Make sure \"Top\" is not included twice on pages","ref":"changelog.html#v0-14-2"},{"type":"extras","title":"v0.14.1 - Changelog","doc":"* Bug fixes\n    * Include \"Top\" link in pages with no headings\n    * Include \"Top\" link in modules with no docs","ref":"changelog.html#v0-14-1"},{"type":"extras","title":"v0.14.0 - Changelog","doc":"* Enhancements\n    * Add support for the epub formatter\n    * Support extraction from ` ` headers out of the settext format\n\n  * Layout changes\n    * Indent documentation inside the function/macro/type/callback header\n    * Style types the same way as function/macro/callback and include a link to the source\n    * Increase font-sizes in the sidebar and code snippets\n    * Move the specs definition inside the function/macro/type/callback header and make better use of vertical space\n    * Use a gradient on the sidebar to avoid sudden cut-off when scrolling the modules list\n    * Fix the use of the back-button in some browsers\n    * Allow the whole sidebar to be navigated without moving away from the current page. Expand (+) and collapse (-) buttons have been added to aid exploration\n    * Numerically order pages/guides headers","ref":"changelog.html#v0-14-0"},{"type":"extras","title":"v0.13.2 - Changelog","doc":"* Bug fixes\n    * Avoid scrollbar from appearing on all code snippets","ref":"changelog.html#v0-13-2"},{"type":"extras","title":"v0.13.1 - Changelog","doc":"* Enhancements\n    * Autolink Elixir's stdlib modules and functions\n    * Show callbacks in search results\n    * Reduce size taken by font-sizes\n    * Increase size for headings in the moduledoc\n\n  * Bug fixes\n    * Fix opened sidebar on small screens\n    * Allow horizontal scrolling for code snippets on small screens","ref":"changelog.html#v0-13-1"},{"type":"extras","title":"v0.13.0 - Changelog","doc":"* Bug fixes\n    * Fix issue where docs would fail when being built on Erlang 19\n    * Store templates in `priv` rather than in `lib`\n\n  * Backwards incompatible changes\n    * Require Elixir ~> v1.2","ref":"changelog.html#v0-13-0"},{"type":"extras","title":"v0.12.0 - Changelog","doc":"* Enhancements\n    * Remove warnings when running on Elixir v1.3\n    * Support for `@optional_callbacks`\n    * Improve styling for nested lists\n    * Include earmark as a default dependency\n\n  * Bug fixes\n    * Fix many styling and performance front-end related bugs","ref":"changelog.html#v0-12-0"},{"type":"extras","title":"v0.11.5 - Changelog","doc":"* Enhancements\n    * Support canonical URLs\n\n  * Bug fixes\n    * Autolink now allows digits in function names\n    * Sort specs by line to preserve ordering\n    * Focus on content element on document ready\n    * Remove ligature fix on Firefox and Safari as Google Fonts have been updated","ref":"changelog.html#v0-11-5"},{"type":"extras","title":"v0.11.4 - Changelog","doc":"* Bug fixes\n    * Fix ligature issues in recent browsers\n    * HTML escape headers\n    * Avoid warning on Elixir master (v1.3)","ref":"changelog.html#v0-11-4"},{"type":"extras","title":"v0.11.3 - Changelog","doc":"* Bug fixes\n    * Fix a regression where the sidebar wouldn't stick on small screens","ref":"changelog.html#v0-11-3"},{"type":"extras","title":"v0.11.2 - Changelog","doc":"* Enhancements\n    * Include night mode for docs\n    * Take advantage of extra space on large screens by widening sidebar\n\n  * Bug fixes\n    * Do not attempt to retrieve docs from Erlang modules","ref":"changelog.html#v0-11-2"},{"type":"extras","title":"v0.11.1 - Changelog","doc":"* Bug fixes\n    * Include callbacks even if a module defines a struct","ref":"changelog.html#v0-11-1"},{"type":"extras","title":"v0.11.0 - Changelog","doc":"* Enhancements\n    * From now on it's possible to set the title in the sidebar area for\n      additional content, *default:* \"Pages\"\n    * Set the path and title of each additional page in `mix.exs` file\n    * Use the first `h1` as menu title if title is not configured\n    * Include the project name as part of the header in small devices\n\n  * Bug fixes\n    * Increase the visual separation between functions\n    * Remove the `extra-` prefix for the additional documentation files\n    * Extra large images do not create an overflow in the content","ref":"changelog.html#v0-11-0"},{"type":"extras","title":"v0.10.0 - Changelog","doc":"* Enhancements\n    * Many improvements and bug fixes in new layout\n    * Reduced build size\n    * Overview has been renamed to API Reference\n    * All extra content, including API Reference, has been moved to inside\n      \"Pages\"\n    * Extra files are now downcased and prefixed by `extra-`","ref":"changelog.html#v0-10-0"},{"type":"extras","title":"v0.9.0 - Changelog","doc":"* Enhancements\n    * Whole new clean, readable, usable, responsive layout\n    * Support for adding logo to generated docs (must be 64x64 pixels)\n    * Support for adding extra pages to generated docs\n    * Improve formatting of typespecs and callbacks\n\n  * Backwards incompatible changes\n    * `--readme` option and `:readme` configuration have been removed. Use\n      `:extras` in your `mix.exs` file or pass `--extra` / `-e` in the\n      command-line (may be given multiple times)","ref":"changelog.html#v0-9-0"},{"type":"extras","title":"v0.8.4 - Changelog","doc":"* Bug fixes\n    * Generate `README.html` file instead of `readme.html` as in previous\n      releases\n    * Style fixes in the new layout","ref":"changelog.html#v0-8-4"},{"type":"extras","title":"v0.8.3 - Changelog","doc":"* Bug fixes\n    * Style fixes in the new layout","ref":"changelog.html#v0-8-3"},{"type":"extras","title":"v0.8.2 - Changelog","doc":"* Enhancements\n    * Uglify and minify JS and CSS code\n    * Performance improvements when building sidebar\n    * Redirect from index.html to proper page\n\n  * Bug fixes\n    * Style fixes in the new layout","ref":"changelog.html#v0-8-2"},{"type":"extras","title":"v0.8.1 - Changelog","doc":"* Bug fixes\n    * Style fixes in the new layout","ref":"changelog.html#v0-8-1"},{"type":"extras","title":"v0.8.0 - Changelog","doc":"* Enhancements\n    * New and responsive layout without frames","ref":"changelog.html#v0-8-0"},{"type":"extras","title":"v0.7.3 - Changelog","doc":"* Bug fixes\n    * Update [highlight.js][] with fixes some inlining issues\n    * Require latest [Earmark][]","ref":"changelog.html#v0-7-3"},{"type":"extras","title":"v0.7.2 - Changelog","doc":"* Bug fixes\n    * Support Elixir master\n    * Fix error reporting when modules are compiled without docs","ref":"changelog.html#v0-7-2"},{"type":"extras","title":"v0.7.1 - Changelog","doc":"* Enhancements\n    * Use `type=search` for search input\n    * Update [highlight.js][] dependency\n    * Properly tag code comments as coming from Elixir/IEx unless noted otherwise\n    * Add support for hash redirection","ref":"changelog.html#v0-7-1"},{"type":"extras","title":"v0.7.0 - Changelog","doc":"* Enhancements\n    * Documentation is now generated at `doc` to follow OTP \"standard\"","ref":"changelog.html#v0-7-0"},{"type":"extras","title":"v0.6.2 - Changelog","doc":"* Enhancements\n    * Improvements to the document structure\n    * Add syntax highlight","ref":"changelog.html#v0-6-2"},{"type":"extras","title":"v0.6.1 - Changelog","doc":"* Enhancements\n    * Autolink modules and functions in the README\n    * Generate ids for callbacks starting with \"c:\"\n    * Ensure group ordering is consistent: TYPES > FUNCTIONS > MACROS > CALLBACKS\n    * Allow users to search by Module.function","ref":"changelog.html#v0-6-1"},{"type":"extras","title":"v0.6.0 - Changelog","doc":"* Enhancements\n    * Support Elixir v1.0.0-rc1","ref":"changelog.html#v0-6-0"},{"type":"extras","title":"v0.5.2 - Changelog","doc":"* Bug fixes\n    * Use proper ANSI escape sequence on Mix success messages","ref":"changelog.html#v0-5-2"},{"type":"extras","title":"v0.5.1 - Changelog","doc":"* Enhancements\n    * Support Elixir v0.15.0\n    * Add support for [Earmark][] - no need for external processors","ref":"changelog.html#v0-5-1"},{"type":"extras","title":"v0.5.0 - Changelog","doc":"* Enhancements\n    * First public release\n    * Support [pandoc][] and [devinus/markdown][markdown] as markdown processors\n\n[pandoc]: http://pandoc.org/\n[markdown]: https://github.com/devinus/markdown\n[earmark]: https://github.com/pragdave/earmark\n[highlight.js]: https://highlightjs.org/","ref":"changelog.html#v0-5-0"}],"proglang":"elixir","content_type":"text/markdown","producer":{"name":"ex_doc","version":"0.37.0"}}